﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:template name="showSound">
<xsl:param name="soundId"/>
		<!--object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="17" height="17" align="absmiddle"-->
		<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" width="16" height="16" align="absmiddle" id="flash_sound">
			<param name="movie" value="images/voice.swf" />
			<param name="loop" value="false" />
			<param name="play" value="false" />
			<param name="menu" value="false" />
			<param name="quality" value="high" />
			<param name="allowScriptAccess" value="always" />
			<xsl:element name="param">
				<xsl:attribute name="name">FlashVars</xsl:attribute>
				<xsl:attribute name="value">audio=http://dict.youdao.com/speach?audio=<xsl:value-of select="$soundId"/>&amp;keyfrom=deskdict.main</xsl:attribute>
			</xsl:element>
		</object>
</xsl:template>

<!-- 发音小喇叭模板 -->
<xsl:template match="speech|dictcn-speach">
<xsl:param name="objId"/>
	<xsl:if test="text()!=''">
	<xsl:element name="span">
		<xsl:attribute name="id">showSound<xsl:value-of select="$objId"/></xsl:attribute>
		<xsl:attribute name="style">display:inline</xsl:attribute>
		<xsl:call-template name="showSound">
			<xsl:with-param name="soundId" select="."/>
		</xsl:call-template>
	</xsl:element>

	<xsl:element name="span">
		<xsl:attribute name="id">noSound<xsl:value-of select="$objId"/></xsl:attribute>
		<xsl:attribute name="style">display:none</xsl:attribute>
		<a href="http://www.adobe.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash" target="_blank">
			<IMG SRC="images/nosound.gif" WIDTH="17" HEIGHT="17" BORDER="0" ALT="想启用英文朗读功能吗？请先安装flash插件！" align="absmiddle" />
		</a>
	</xsl:element>
	</xsl:if>
</xsl:template>

<xsl:template name="data_from">
<xsl:param name="from_type"/>
<xsl:param name="from_name"/>
<xsl:param name="from_url"/>
	<div id="source">以上来源于:
		<xsl:choose>
			<xsl:when test="$from_url=''">
				<xsl:value-of select="$from_name"/>
			</xsl:when>
			<xsl:otherwise>
			<xsl:element name="a">
				<xsl:attribute name="href"><xsl:value-of select="$from_url"/></xsl:attribute>
				<xsl:attribute name="class">graylaiyuan</xsl:attribute>
				<xsl:attribute name="target">_blank</xsl:attribute>
				<xsl:attribute name="onclick">javascript:ctlog(this, "<xsl:call-template name="standard_return_phrase" />", 1, 1, 1, 'CLICK', '<xsl:value-of select="$from_name"/>'+'_deskdict')</xsl:attribute>
				<xsl:value-of select="$from_name"/>
			</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
		
	</div>		
</xsl:template>

<xsl:template match="source">
<xsl:param name="dict_type"/>
	<xsl:if test=".">
		<xsl:call-template name="data_from">
			<xsl:with-param name="from_type"></xsl:with-param>
			<xsl:with-param name="from_name" select="name"/>
			<xsl:with-param name="from_url" select="url"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

<xsl:template name="baike_tab">
	<div id="tabbar">
		<div class="barimg"><img src="images/titlesymbol.gif" /></div>
		<div class="left">百科</div>
	</div>
</xsl:template>

<!-- 替换函数 -->
<xsl:template   name="SubStringFun">   
  <xsl:param   name="input" />   
    <xsl:param   name="from" />   
    <xsl:param   name="to" />   
    <xsl:if   test="$input">   
  <xsl:choose>   
  <xsl:when   test="contains($input,$from)">   
  <xsl:value-of   select="substring-before($input,$from)"/><xsl:value-of   select="$to"/><xsl:call-template   name="SubStringFun">   
  <xsl:with-param   name="input"   select="substring-after($input,$from)"   />   
  <xsl:with-param   name="from"   select="$from"   />   
  <xsl:with-param   name="to"   select="$to"   />   
  </xsl:call-template>   
  </xsl:when>   
  <xsl:otherwise>   
  <xsl:value-of   select="$input"   />   
  </xsl:otherwise>   
  </xsl:choose>   
    </xsl:if>   
</xsl:template>

<!-- 输出标准的return_phrase字段,去掉其中的‘\’符号 -->
<xsl:template name="standard_return_phrase">
  <xsl:call-template   name="SubStringFun">   
  	<xsl:with-param   name="input"   select="/yodaodict/return-phrase"   />   
	<xsl:with-param   name="from"   select="'\'"   />   
    <xsl:with-param   name="to"   select="'\\'"   />   
  </xsl:call-template>
</xsl:template>

<xsl:template name="baike_more">
<xsl:param name="key"/>
	<div class="more">
		<xsl:element name="a">
			<xsl:attribute name="href">app:bks:<xsl:value-of select="$key"/></xsl:attribute>
			<xsl:attribute name="target">_self</xsl:attribute>
			更多与"<xsl:value-of select="$key"/>"相关的百科词条&gt;&gt;
		</xsl:element>
	</div>
</xsl:template>

<xsl:template name="baike_item">
	<xsl:param name="key"/>
	<xsl:param name="summary"/>
	<xsl:param name="image"/>
	<xsl:param name="show_more"/>
		<div class="word">
			<xsl:element name="a">
				<xsl:attribute name="href">app:bk:<xsl:value-of select="$key" /></xsl:attribute>
				<xsl:attribute name="target">_self</xsl:attribute>
				<xsl:attribute name="class">bluebigtt</xsl:attribute>
				<xsl:value-of select="$key" />
			</xsl:element>
		</div>
    <div class="content">
    	<div class="right">
				<xsl:if test="$image!=''">
					<xsl:element name="img">
						<xsl:attribute name="src"><xsl:value-of select="$image" />&amp;thumbnail</xsl:attribute>
						<xsl:attribute name="border">0</xsl:attribute>
						<xsl:attribute name="align">absmiddle</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</div>
    	<div class="left"><xsl:value-of select="summary" />......  	
	    <xsl:if test="$show_more = 'true'">
		    <span class="details" style="white-space: nowrap;">
					<xsl:element name="a">
						<xsl:attribute name="href">app:bk:<xsl:value-of select="$key" /></xsl:attribute>
						<xsl:attribute name="target">_self</xsl:attribute>
						详细内容&gt;&gt;
					</xsl:element>		
				</span>
			</xsl:if>	
			</div>  	
		</div>
		<xsl:if test="$show_more = 'true'">
			<xsl:call-template name="baike_more">
			<xsl:with-param name="key" select="$key"/>
   		</xsl:call-template>
   	</xsl:if>
</xsl:template>

<xsl:template name="basic_tab">
	<xsl:param name="tab_type"/>
	<xsl:param name="tab_num"/>

		<!-- 显示Tab标签 -->		
		<div id="tabbar">
			<div class="barimg">
				<img src="images/titlesymbol.gif" />
			</div>
			<div class="left">
				<xsl:if test="$tab_type[text()='ec']">
				英汉翻译
				</xsl:if>
				<xsl:if test="$tab_type[text()='ce']" >				
				汉英翻译
				</xsl:if>
				<xsl:if test="$tab_type[text()='ee']" >	
					<xsl:if test="$tab_num &gt; 1">
					<xsl:element name="a">
		  	 		<xsl:attribute name="href">javascript:void(0)</xsl:attribute>   			
			   		<xsl:attribute name="target">_self</xsl:attribute>
			   		<xsl:attribute name="title">英汉翻译</xsl:attribute>
			   		<xsl:attribute name="onclick">javascript:showEngChn(true)</xsl:attribute>
						英汉翻译
			    	</xsl:element>
					</xsl:if>
				</xsl:if>
				<xsl:if test="$tab_type[text()='trans']" >
					翻译
				</xsl:if>
			</div>
			<div class="left">
			<xsl:if test="$tab_type[text()!='ee']" >
				<xsl:if test="$tab_num &gt; 1">
					<xsl:element name="a">
		  	 		<xsl:attribute name="href">javascript:void(0)</xsl:attribute>   			
			   		<xsl:attribute name="target">_self</xsl:attribute>
		   			<xsl:attribute name="title">英英翻译</xsl:attribute>
		   			<xsl:attribute name="onclick">javascript:showEngEng(true)</xsl:attribute>
						英英翻译
			    	</xsl:element>
				</xsl:if>

	    	</xsl:if>
			<xsl:if test="$tab_type[text()='ee']" >
					英英翻译
			</xsl:if>
			</div>
		</div>
</xsl:template>

<xsl:template name="keyword_line">
<xsl:param name="keyword"/>
<xsl:param name="phone"/>
<xsl:param name="speech"/>
	<xsl:if test="$keyword">
		<!--div style="float:left;width:20px"> </div-->
		<div style="float:left;">
			<div class="keywordline">
					<span class="keyword">
					<xsl:choose>
						<xsl:when test="$keyword/l">
							<xsl:apply-templates select="$keyword/l"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$keyword" />
						</xsl:otherwise>
					</xsl:choose>
					</span>
					
					<!-- 音标 -->
					<xsl:if test="$phone[text()!='']">
						<span class= "pronounce">
					  	 [<xsl:value-of select="$phone" />]
					  </span>
					</xsl:if>
					<!-- 输出发音-->
					<xsl:if test="$speech[text()!='']">
					<xsl:apply-templates select="$speech">
						<xsl:with-param name="objId" select="'EC'"/>
					</xsl:apply-templates>
					</xsl:if>
			</div>
		</div>
		<div style="overflow:hidden;height:1px;clear:both"></div>
	</xsl:if>
</xsl:template>

<!-- 输出line -->
<xsl:template match="l">
	<xsl:for-each select="i">
		<xsl:choose>
		 <xsl:when test="@action">
			<!-- 处理link -->
			 <xsl:if test="@action='link'">
		 		<xsl:choose>
				 <xsl:when test="@href">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
						<xsl:attribute name="target"><xsl:value-of select="@target"/></xsl:attribute>
						<xsl:value-of select="." />
					</xsl:element>
				</xsl:when>
				<xsl:otherwise>
					<xsl:element name="a">
						<xsl:attribute name="href">app:ds:<xsl:value-of select="." /></xsl:attribute>
						<xsl:value-of select="." />
					</xsl:element>
				</xsl:otherwise>
				</xsl:choose>
			 </xsl:if>
			<!-- 处理高亮 -->
			 <xsl:if test="@action='highlight'">
				 <strong><xsl:value-of select="."/></strong>
			 </xsl:if>
 			<!-- 处理上标 -->
			 <xsl:if test="@action='sup'">
			 	<sup style="font-size:85%;"><xsl:value-of select="."/></sup>
			 </xsl:if>
		 </xsl:when>
		 <xsl:otherwise>
			<!-- 如果什么都没有，就如实输出-->
			<xsl:value-of select="." />
		 </xsl:otherwise>
	 	</xsl:choose>	 
	</xsl:for-each>
</xsl:template>

<!-- 简明词典模板-->
<xsl:template match="simple-dict">
	<xsl:for-each select="word">
		<div id="classic" >
			<!-- 输出关键词、音标、发音小喇叭 -->
			<xsl:call-template name="keyword_line">
				<xsl:with-param name="keyword" select="return-phrase"/>
				<xsl:with-param name="phone" select="phone"/>
				<xsl:with-param name="speech" select="speech"/>
			</xsl:call-template>
			<div style="overflow:hidden;height:1px;"></div>
			<!-- 循环输出解释项 -->
			<xsl:for-each select="trs/tr">
				<div class="meaning">
					<xsl:apply-templates select="l"/>
				</div>
			</xsl:for-each>
			
			<!-- 输出单词变形-->
			<xsl:if test="wfs">
				<div class="attr">[
				    	<xsl:for-each select="wfs/wf">
				    	 	<xsl:value-of select="name" /> <xsl:value-of select="value" /> &#000032;
				    	</xsl:for-each> ]
				</div>
			</xsl:if>		
		
			<xsl:if test="similar-words">
				<div class="attr">
				  <IMG SRC="images/pointd.gif" WIDTH="5" HEIGHT="5" BORDER="0" ALT="" align="absmiddle"/>
				<font class="dot">. </font>
				<B>近义词或词组</B>
			  </div>		
			  <div class="attr">
					<span>
					<xsl:for-each select="similar-words/similar">
						<xsl:if test="position() &lt;= 4" >
						<xsl:element name="a">
							<xsl:attribute name="href">app:ds:<xsl:value-of select="." /></xsl:attribute>
							<xsl:attribute name="class">blue12other</xsl:attribute>
							<xsl:attribute name="target">_self</xsl:attribute>
							<xsl:value-of select="." />
						</xsl:element>
						<xsl:if test="not(position() = count(../similar)) and not(position() = 4) "> | </xsl:if> 
						</xsl:if>
					</xsl:for-each>
					</span>			
					<span  id="moreSimwords" style="display:none">
					<xsl:for-each select="similar-words/similar">
						<xsl:if test="position() &gt; 4" >
							 | 
							<xsl:element name="a">
								<xsl:attribute name="href">app:ds:<xsl:value-of select="." /></xsl:attribute>
								<xsl:attribute name="class">blue12other</xsl:attribute>
								<xsl:attribute name="target">_self</xsl:attribute>
								<xsl:value-of select="." />
							</xsl:element>
						</xsl:if>
						</xsl:for-each>
					</span>		
					<xsl:if test="count(similar-words/similar) &gt; 4" >
						<xsl:element name="span">
							<xsl:attribute name="id">showmoreSimwords</xsl:attribute>
							<font class="dot"> . </font>
							<IMG SRC="images/dictrstarbu.gif" WIDTH="4" HEIGHT="8" BORDER="0" ALT="展开" align="absmiddle"/>
							<xsl:element name="a">
		  	 				<xsl:attribute name="href">javascript:void(0)</xsl:attribute>
			   				<xsl:attribute name="title">点击查看更多的近义词</xsl:attribute>
								<xsl:attribute name="onclick">changeMoreSpan('moreSimwords')</xsl:attribute>
								更多
		    			</xsl:element>
						</xsl:element>
		
						<xsl:element name="span">
							<xsl:attribute name="id">hidemoreSimwords</xsl:attribute>
							<xsl:attribute name="style">display:none</xsl:attribute>
							<font class="dot"> . </font>
							<IMG SRC="images/dictlstarbu.gif" WIDTH="4" HEIGHT="8" BORDER="0" ALT="隐藏更多" align="absmiddle"/>
							<xsl:element name="a">
		  	 				<xsl:attribute name="href">javascript:void(0)</xsl:attribute>
		   					<xsl:attribute name="class">blue12other</xsl:attribute>
								<xsl:attribute name="onclick">changeMoreSpan('moreSimwords')</xsl:attribute>
								隐藏更多
		    			</xsl:element>
						</xsl:element>
					</xsl:if>
				</div>
			</xsl:if>
			<xsl:if test="/yodaodict/basic/type[text()='trans']">
			<br/>
			<span style="color:#666666">
			来自<xsl:element name="a"><xsl:attribute name="href">app:trans:<xsl:value-of select="/yodaodict/return-phrase" /></xsl:attribute>有道翻译</xsl:element>的自动转换
			</span>
			</xsl:if>
		</div>
	</xsl:for-each>

</xsl:template>

<!-- 词性模板 -->
<xsl:template name="category">
	<xsl:param name="cat_name"/>
	<xsl:param name="cat_extra"/>
	<div style="padding-top:6px">
		<span><IMG SRC="images/graypoint.gif" WIDTH="9" HEIGHT="9" BORDER="0" ALT="" align="bottom"/></span>
		<span class="pos"><xsl:value-of select="$cat_name"/></span>
		<span style="margin-left:5px"> <xsl:value-of select="$cat_extra" disable-output-escaping="no"/> </span>
	</div>
	<div style="overflow:hidden;height:1px;clear:both"></div>
	
</xsl:template>

<!-- 权威词典中的例句模板-->
<xsl:template match="exam">
	<xsl:if test="i">
	<div style="float:left;width:20px"> </div>
	<div style="float:left;"><span style="color:#666666">例句: </span></div>
	<div style="float:left;width:4px"> </div>
	<xsl:for-each select="i">
	<xsl:if test="position() &gt; 1" >
		<div style="float:left;width:50px"> </div>
	</xsl:if>
	<div  style="float:left;">
		  <span style="color:#333333"><xsl:apply-templates select="f/l"/></span>
		  <BR/>
		  <span style="color:#666666"><xsl:apply-templates select="n/l"/></span>
	</div>
	<div style="overflow:hidden;height:1px;clear:both"></div> 
	</xsl:for-each>
	</xsl:if>
</xsl:template>

<!-- 近义词/反义词模板 -->
<xsl:template match="syno|anto">
<xsl:param name="cat_title"/>
	<xsl:call-template name="category">
		<xsl:with-param name="cat_name"><xsl:value-of select="$cat_title"/></xsl:with-param>
		<xsl:with-param name="cat_extra"></xsl:with-param>
	</xsl:call-template>
	<div style="float:left;width:6px"> </div>
		<div class="meaning">
			<xsl:for-each select="i">
					<xsl:element name="a">
						<xsl:attribute name="href">app:ds:<xsl:value-of select="." /></xsl:attribute>
						<xsl:value-of select="." />
					</xsl:element> <font class="dot"> . </font>
			</xsl:for-each>
		</div>
</xsl:template>

<!-- 权威词典中的词性 -->
<xsl:template match="wfs">
  <xsl:if test="wf">
	<xsl:call-template name="category">
		<xsl:with-param name="cat_name">变形:</xsl:with-param>
		<xsl:with-param name="cat_extra"></xsl:with-param>
	</xsl:call-template>

	<xsl:for-each select="wf">
		<div style="margin-left:16px">
			<xsl:value-of select="pos" />
			<xsl:for-each select="i">
				<span style="margin-left:5px;">
					<xsl:element name="a">
						<xsl:attribute name="href">app:ds:<xsl:value-of select="." /></xsl:attribute>
						<xsl:value-of select="." />
					</xsl:element>
				</span>
			</xsl:for-each>
		</div>
	</xsl:for-each>
  </xsl:if>
</xsl:template>
<!-- 词组短语模板 -->
<xsl:template match="phrs">
	<xsl:call-template name="category">
		<xsl:with-param name="cat_name">短语</xsl:with-param>
		<xsl:with-param name="cat_extra"></xsl:with-param>
	</xsl:call-template>

	<xsl:for-each select="i">
		<div style="float:left;width:6px"> </div>
		<xsl:if test="count(../i) &gt; 1">
			<div style="float:left;margin-right:5px"><xsl:number value="position()" format="1. "/></div>
		</xsl:if>
		<div style="float:left;">
			<div style="float:left;margin-left:0px">
				
				<xsl:apply-templates select="phr/l" />
				<span style="width:8px"> </span>
				<xsl:apply-templates select="des/l" />
			</div>
			<xsl:if test="tr">
				<br/>
				<xsl:for-each select="tr/l">
					<div style="margin-left:10px;">
					<xsl:number value="position()" format="a. "/>
					<xsl:apply-templates select="."/>
					</div>
				</xsl:for-each>			
			</xsl:if>
		</div>
		<div style="overflow:hidden;height:1px;clear:both"></div>
	</xsl:for-each>
</xsl:template>

<xsl:template match="tr">
<xsl:param name="num"/>
<xsl:param name="level_num"/>
	<div style="float:left;width:10px"> </div>
	<xsl:if test="$num">
		<div style="float:left;margin-right:5px"><xsl:value-of select="$num"/></div>
	</xsl:if>
	<div style="float:left;">
		<xsl:apply-templates select="l"/>
		<!-- 输出解释的子项-->
		<xsl:for-each select="./tr">
			<xsl:apply-templates select=".">
				<xsl:with-param name="num">
					<!-- 这里对输出的序号格式做个规划 -->
					<xsl:if test="$level_num='1'"> <xsl:number value="position()" format="1) "/> </xsl:if>
					<xsl:if test="$level_num='2'"> <xsl:number value="position()" format="a. "/> </xsl:if>
					<xsl:if test="$level_num='3'"> <xsl:number value="position()" format="a) "/> </xsl:if>
					<!--xsl:if test="number($level_num)>=4">~</xsl:if-->
				</xsl:with-param>
				<xsl:with-param name="level_num" select="number($level_num)+1" />
			</xsl:apply-templates>
		</xsl:for-each>
	</div>
	<div style="overflow:hidden;height:1px;clear:both"></div> 
	<!-- 输出例句 -->
	<xsl:apply-templates select="exam"/>
</xsl:template>

<xsl:template match="authoritative-dict">
	<xsl:for-each select="word">
		<xsl:if test="position() &gt; 1" >
			<div style="overflow:hidden;height:1px;background:url(images/graypointpoint.gif) repeat-x;margin-top:10px;clear:both"/>
		</xsl:if>
		<div id="classic" border="0" cellpadding="0" cellspacing="0" >
			<!-- 输出关键词、音标、发音小喇叭 -->
			<xsl:call-template name="keyword_line">
				<xsl:with-param name="keyword" select="return-phrase"/>
				<xsl:with-param name="phone" select="phone"/>
				<xsl:with-param name="speech" select="speech"/>
			</xsl:call-template>
							
			<!-- 循环输出解释项 -->
			<xsl:for-each select="trs">
				<!-- 如果只有一项，则和词性放在同一行-->
				<xsl:if test="count(tr)=1">
					<div style="float:left;padding-top:6px">
						<span><IMG SRC="images/graypoint.gif" WIDTH="9" HEIGHT="9" BORDER="0" ALT="" align="bottom"/></span>
						<span class="pos"><xsl:value-of select="pos"/></span>
					</div>
					<div style="float:left;margin-left:0px;padding-top:6px"> 
						<xsl:apply-templates select="tr">
						<!--xsl:with-param name="num"/-->
						<xsl:with-param name="level_num">1</xsl:with-param>
						</xsl:apply-templates>
					</div>
					<div style="overflow:hidden;height:2px;clear:both"></div>
				</xsl:if>

				
				<xsl:if test="count(tr) &gt; 1">
					<xsl:call-template name="category">
						<xsl:with-param name="cat_name" select="pos"/>
						<xsl:with-param name="cat_extra"/>
					</xsl:call-template>
					
					<xsl:for-each select="tr">
						<!-- 输出解释 -->
						<xsl:apply-templates select=".">
							<xsl:with-param name="num">
								<xsl:number value="position()" format="1. "/>
							</xsl:with-param>
							<xsl:with-param name="level_num">1</xsl:with-param>
						</xsl:apply-templates>
					</xsl:for-each>
				</xsl:if>
			</xsl:for-each>
			
			<!-- 显示近义词 反义词-->
			<xsl:apply-templates select="syno">
				<xsl:with-param name="cat_title">近义词:</xsl:with-param>
			</xsl:apply-templates>
			<xsl:apply-templates select="anto">
				<xsl:with-param name="cat_title">反义词:</xsl:with-param>
			</xsl:apply-templates>
			
			<!-- 显示短语-->
			<xsl:apply-templates select="phrs"/>
			
			<!-- 显示词性变形-->
			<xsl:apply-templates select="wfs"/>
		</div>
	</xsl:for-each>
	<xsl:apply-templates select="source">
		<xsl:with-param name="dict_type"><xsl:value-of select="../type"/></xsl:with-param>
	</xsl:apply-templates>
</xsl:template>

</xsl:stylesheet>